<?php
/**
 * CargoOrderFillableProperties
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Logistic
 *
 * Управление логистикой
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\LogisticClient\Dto;

use \ArrayAccess;
use \Ensi\LogisticClient\ObjectSerializer;

/**
 * CargoOrderFillableProperties Class Doc Comment
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class CargoOrderFillableProperties implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'CargoOrderFillableProperties';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'status' => 'int',
        'cargo_id' => 'int',
        'timeslot_id' => 'string',
        'timeslot_from' => '\DateTime',
        'timeslot_to' => '\DateTime',
        'date' => '\DateTime'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'status' => null,
        'cargo_id' => null,
        'timeslot_id' => null,
        'timeslot_from' => 'date-time',
        'timeslot_to' => 'date-time',
        'date' => 'date-time'
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'status' => false,
        'cargo_id' => false,
        'timeslot_id' => false,
        'timeslot_from' => false,
        'timeslot_to' => false,
        'date' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::openAPINullables()[$property])) {
            return self::openAPINullables()[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'status' => 'status',
        'cargo_id' => 'cargo_id',
        'timeslot_id' => 'timeslot_id',
        'timeslot_from' => 'timeslot_from',
        'timeslot_to' => 'timeslot_to',
        'date' => 'date'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'status' => 'setStatus',
        'cargo_id' => 'setCargoId',
        'timeslot_id' => 'setTimeslotId',
        'timeslot_from' => 'setTimeslotFrom',
        'timeslot_to' => 'setTimeslotTo',
        'date' => 'setDate'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'status' => 'getStatus',
        'cargo_id' => 'getCargoId',
        'timeslot_id' => 'getTimeslotId',
        'timeslot_from' => 'getTimeslotFrom',
        'timeslot_to' => 'getTimeslotTo',
        'date' => 'getDate'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('status', $data, null);
        $this->setIfExists('cargo_id', $data, null);
        $this->setIfExists('timeslot_id', $data, null);
        $this->setIfExists('timeslot_from', $data, null);
        $this->setIfExists('timeslot_to', $data, null);
        $this->setIfExists('date', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets status
     *
     * @return int|null
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param int|null $status status
     *
     * @return $this
     */
    public function setStatus($status)
    {


        /*if (is_null($status)) {
            throw new \InvalidArgumentException('non-nullable status cannot be null');
        }*/
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets cargo_id
     *
     * @return int|null
     */
    public function getCargoId()
    {
        return $this->container['cargo_id'];
    }

    /**
     * Sets cargo_id
     *
     * @param int|null $cargo_id Идентификатор груза
     *
     * @return $this
     */
    public function setCargoId($cargo_id)
    {


        /*if (is_null($cargo_id)) {
            throw new \InvalidArgumentException('non-nullable cargo_id cannot be null');
        }*/
        $this->container['cargo_id'] = $cargo_id;

        return $this;
    }

    /**
     * Gets timeslot_id
     *
     * @return string|null
     */
    public function getTimeslotId()
    {
        return $this->container['timeslot_id'];
    }

    /**
     * Sets timeslot_id
     *
     * @param string|null $timeslot_id Идентификатор таймслота
     *
     * @return $this
     */
    public function setTimeslotId($timeslot_id)
    {


        /*if (is_null($timeslot_id)) {
            throw new \InvalidArgumentException('non-nullable timeslot_id cannot be null');
        }*/
        $this->container['timeslot_id'] = $timeslot_id;

        return $this;
    }

    /**
     * Gets timeslot_from
     *
     * @return \DateTime|null
     */
    public function getTimeslotFrom()
    {
        return $this->container['timeslot_from'];
    }

    /**
     * Sets timeslot_from
     *
     * @param \DateTime|null $timeslot_from Дата забора груза
     *
     * @return $this
     */
    public function setTimeslotFrom($timeslot_from)
    {


        /*if (is_null($timeslot_from)) {
            throw new \InvalidArgumentException('non-nullable timeslot_from cannot be null');
        }*/
        $this->container['timeslot_from'] = $timeslot_from;

        return $this;
    }

    /**
     * Gets timeslot_to
     *
     * @return \DateTime|null
     */
    public function getTimeslotTo()
    {
        return $this->container['timeslot_to'];
    }

    /**
     * Sets timeslot_to
     *
     * @param \DateTime|null $timeslot_to Дата забора груза
     *
     * @return $this
     */
    public function setTimeslotTo($timeslot_to)
    {


        /*if (is_null($timeslot_to)) {
            throw new \InvalidArgumentException('non-nullable timeslot_to cannot be null');
        }*/
        $this->container['timeslot_to'] = $timeslot_to;

        return $this;
    }

    /**
     * Gets date
     *
     * @return \DateTime|null
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     *
     * @param \DateTime|null $date Дата забора груза
     *
     * @return $this
     */
    public function setDate($date)
    {


        /*if (is_null($date)) {
            throw new \InvalidArgumentException('non-nullable date cannot be null');
        }*/
        $this->container['date'] = $date;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset): mixed
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
    * Convert object to array
    *
    * @return array
    */
    public function toArray()
    {
        return json_decode(json_encode(ObjectSerializer::sanitizeForSerialization($this)), true);
    }
}


